/** 
 *
 * @author Zhuplev Anton
 */
import java.io.*;
import java.util.*;



public class sol_zhuplev implements Runnable {

  
  private String input = "input.txt";
  private String output = "output.txt";
  private BufferedReader in = null;
  private PrintStream out = null;
   
  
  public sol_zhuplev() {
    try {
      in = new BufferedReader(new FileReader(input));
      out = new PrintStream(new FileOutputStream(output));
    } catch (Exception exept) {
      exept.printStackTrace();
      System.exit(1);
    }
  }

  
  public static void main(String[] args) {
    Locale.setDefault(Locale.US);
    new Thread(new sol_zhuplev()).start();
  }


  public void run() {
    try {
      solve();
    } catch (Exception exept) {
      exept.printStackTrace();
      System.exit(1);
    } finally {
      out.flush();
      out.close();
    }
  }

  
  private void myAssert(boolean expr, String message) {
    if (!expr) {
      throw new Error("Assertion failure!!! " + message);
    }
  }
  
  
  boolean ansExist;
  
  
  @SuppressWarnings("unchecked")
  private void solve() throws IOException {
    ansExist = false;
    StringTokenizer st = new StringTokenizer(in.readLine());
    int n = Integer.parseInt(st.nextToken());
    
    myAssert(1 <= n && n <= 1440 , "Numbers range check");
    
    int  times[] = new int[n];
    for (int i = 0; i < n; i++) {
      String tmp = in.readLine();
      int h = Integer.parseInt(tmp.substring(0, 2));
      int m = Integer.parseInt(tmp.substring(3, 5));
      
      myAssert(0 <= h && h <= 23 , "Hours range check");
      myAssert(0 <= m && m <= 59 , "Minutes range check");
      
      times[i] = 60*h + m;
    }
    
    Arrays.sort(times);
    
    if (times[0] != 0) {
      printInterval(0, times[0] - 1);
    }
    
    for (int i = 1; i < n; i++) {
      if (times[i-1] + 1 < times[i]) {
        printInterval(times[i-1] + 1, times[i] - 1);
      }
    }
    
    if (times[n-1] != 24 * 60 - 1) {
      printInterval(times[n-1] + 1, 24 * 60 - 1);
    }
    
    if (!ansExist) {
      out.println("NONE");
    }
    
  }
  
  
  void printInterval(int l, int r) {
    ansExist = true;
    if (l != r) {
      out.format("%02d:%02d - %02d:%02d\n", l / 60, l % 60, r / 60, r % 60);
    } else {
      out.format("%02d:%02d\n", l / 60, l % 60);
    }
    
  }
  
}
